//ssbow.cs
//rpgbow and rpgbowarrow weapon stuff

//projectile

datablock ProjectileData(greenbowarrowProjectile)
{
   projectileShapeName = "./arrows/sbbowarrow.dts";

   directDamage        = 10;
   directDamageType    = $DamageType::greenbowarrowDirect;

   radiusDamage        = 0;
   damageRadius        = 0;
   radiusDamageType    = $DamageType::greenbowarrowDirect;

   explosion             = greenbowarrowExplosion;
   stickExplosion        = greenbowarrowStickExplosion;
   bloodExplosion        = greenbowarrowStickExplosion;
   particleEmitter       = greenbowarrowTrailEmitter;
   explodeOnPlayerImpact = true;
   explodeOnDeath        = true;  

   armingDelay         = 5000;
   lifetime            = 6000;
   fadeDelay           = 5000;

   isBallistic         = true;
   bounceAngle         = 170; //stick almost all the time
   minStickVelocity    = 10;
   bounceElasticity    = 0.2;
   bounceFriction      = 0.01;   
   gravityMod = 0.10;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   muzzleVelocity      = 110;
   velInheritFactor    = 1;

   uiName = "";
};


//////////
// item //
//////////
datablock ItemData(ssbowitem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./ssbow.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Short Standard Bow";
	iconName = "./icon_ssbow";
	doColorShift = true;
	colorShiftColor = "0.400 0.196 0 1.000";

	 // Dynamic properties defined by the scripts
	image = ssbowimage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(ssbowimage)
{
   // Basic Item properties
   shapeFile = "./ssbow.dts";
   emap = true;

   // Specify mount moss & offset for 3rd person, and eye offset
   // for first person rendering.
   mountmoss = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 10" );

   // When firing from a moss offset from the eye, muzzle correction
   // will adjust the muzzle vector to moss to the eye LOS moss.
   // Since this weapon doesn't actually fire from the muzzle moss,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = ssbowitem;
   ammo = " ";
   projectile = greenbowarrowProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = ssbowitem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = swordDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "StopFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;
	
	stateName[4]                    = "StopFire";
	stateTransitionOnTimeout[4]     = "wait";
	stateTimeoutValue[4]            = 0.2;
	stateAllowImageChange[4]        = false;
	stateWaitForTimeout[4]		= true;
	stateSequence[4]                = "StopFire";
	stateScript[4]                  = "onStopFire";

	stateName[5]                    = "wait";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.6;
	stateWaitForTimeout[5]		= true;


};


